package com.winhc.test;

import com.alibaba.fastjson.JSON;
import com.google.common.collect.ImmutableMap;
import com.mongodb.client.MongoCollection;
import com.mongodb.client.result.UpdateResult;
import com.winhc.common.constant.Base;
import com.winhc.db.mongodb.dataobject.NodeRelationError;
import com.winhc.db.mongodb.repository.NodeRelatonErrorRepository;
import com.winhc.service.EsQueryService;
import com.winhc.service.PidToMongoService;
import com.winhc.service.impl.NodeRelationSuccessStatusServiceImpl;
import org.bson.Document;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.*;

import static com.winhc.utils.DateUtil.formatDate_YYYY_MM_DD_HH_MM_SS;

/**
 * @author π
 * @Description:
 * @date 2021/1/15 16:43
 */
@RunWith(SpringRunner.class)
@SpringBootTest
public class TestMongo {
    @Autowired
    NodeRelatonErrorRepository nodeRelatonErrorRepository;

    @Autowired
    NodeRelationSuccessStatusServiceImpl nodeRelationSuccessStatusServiceImpl;

    @Autowired
    PidToMongoService pidToMongoService;

    @Autowired
    EsQueryService esQueryService;
    @Autowired
    MongoTemplate mongoTemplate;

    @Test
    public void saveData() {
        ArrayList<NodeRelationError> list = new ArrayList<>();
        NodeRelationError n1 = new NodeRelationError();
        n1.setCreateTime(new Date());
        n1.setUpdateTime(new Date());
        n1.setConsumerMessage("{\"start_id\":\"ccdb46273f28d95206f90ea8e1705457\",\"start_name\":\"上饶市广信区田田圈病虫害防治专业合作社\",\"end_id\":\"005d1d5608f046d3b57f725730354494\",\"end_name\":\"\",\"percent\":0.2333,\"deleted\":0,\"holder_type\":2}");
        n1.setErrorMessage("zero error");
        n1.setStatus(1);
        n1.setTopicType("5");
        list.add(n1);
        nodeRelatonErrorRepository.saveAll(list);
    }

    @Test
    public void saveStaus() {
        HashMap<String, Object> m = new HashMap<>();
        m.put("topic_type", "100");
        m.put("ds", "20210219");
        m.put("status", "1");
        ArrayList<Map<String, Object>> list = new ArrayList<>();
        list.add(m);
        nodeRelationSuccessStatusServiceImpl.save(list);
    }

    @Test
    public void insertMongo() {
        ImmutableMap<String, Object> r1 = ImmutableMap.<String, Object>of(
                "_id", "p1",
                "update_time", formatDate_YYYY_MM_DD_HH_MM_SS(),
                "data", ImmutableMap.of(
                        "person_id", "p1"
                        , "name", "钱胜前"
                        , "topic_type", "800"
                )
        );
        ImmutableMap<String, Object> r2 = ImmutableMap.<String, Object>of(
                "_id", "p6",
                "update_time", formatDate_YYYY_MM_DD_HH_MM_SS(),
                "data", ImmutableMap.of(
                        "person_id", "p6"
                        , "name", "曾妍"
                        , "topic_type", "800"
                )
        );
        ImmutableMap<String, Object> r3 = ImmutableMap.<String, Object>of(
                "_id", "p1",
                "update_time", formatDate_YYYY_MM_DD_HH_MM_SS(),
                "data", ImmutableMap.of(
                        "person_id", "p1"
                        , "name", "钱胜前"
                        , "topic_type", "800"
                )
        );
        long start = System.currentTimeMillis();
        int res = pidToMongoService.save(Arrays.asList(r1, r2, r3));
        System.out.println("cost : " + (System.currentTimeMillis() - start));
        System.out.println(res);
    }

    @Test
    public void test11() {
        ImmutableMap<String, String> re = ImmutableMap.of(
                "person_id", "p15d13edfdb5a26ff0285059153b1b9fe"
                , "name", "黄俊强"
                , "topic_type", "800"
        );
        System.out.println(JSON.toJSONString(re));
    }

    @Test
    public void test12() {
        String old_human_pid = "p3f080ea8e694ec29674bdaa606a90c71";
        String new_human_pid = "";
        MongoCollection<Document> collection = mongoTemplate.getCollection(Base.JUDICIAL_CASE_CARD_NUM_V9);
        UpdateResult re = collection.updateMany(new Document("keyno", old_human_pid), new Document("$set", new Document("keyno", new_human_pid)));
        System.out.println(JSON.toJSONString(re));
    }
}
